/* PYL  22 05 2001 */
#include <stdio.h>
#include <stdlib.h>
#include "math.h"
#include "nrutil.h"
/* 12 2000 */
int nx;
int i,n;
int i1, i2;
int ny,N;
double dx0;
double dx;
double dy0,dt;
double *dy;
double *x=NULL;
double *y=NULL;
double *t=NULL;
double *fl=NULL;
double *cw0=NULL;
double *deltac=NULL;
double *delta99=NULL;
double *bjp1=NULL;
double *bjm1=NULL;
double  *bj=NULL;
double  *AA =NULL;
double  *BB =NULL;
double  *B =NULL;
double  *c =NULL;
double  *cim1 =NULL;
double  *wj=NULL;
double *M=NULL;
double *CM=NULL;
double  a;
double  *b, *d;
double  *f;
double  *u;
double c0,cn,t0;
double kon,kof, Rt, h, D,cT, V, L,T ;
double q;
double Da, Pe, K, x1,x2;
FILE  *f3,*f1,*f2;
void lire();
void coefvar();
void remplir();
void inv();
void sauver();

int main(void)
{
int j;
lire();

/*
kE=kon*cT*L/V;
Da=kon*Rt*h/D;
Pe=V*h*h/D/L;
K=kof/kon/cT;
a=1/Pe;
T=T*(kon*cT);
printf("echelle de temps=%lf \n T adim =%lf  Tmaxadim=%lf  \n",1/(kon*cT),T,N*dt);
*/
a=1/Pe;  
 printf(" Da Pe^(-1/3) =%7f \n",Da*pow(Pe,-1./3.));     

t0=0;
// 
i1=x1/dx0;  i2=x2/dx0 ;

 

printf(" i1 = %i \n",i1);
printf(" i2 = %i \n",i2);
//initialisation de B au temps t=0
 f1 = fopen("BM1.OUT", "w");
  fprintf(f1,"%7f %7f 0.0 \n",t0,0 );
 fclose(f1);              
 f3   = fopen("CFw.OUT", "w");   
fclose(f3);
 for (i=1; i<=nx; i++){
B[i]=0;}

for (n=1; n<=N; n++){
M[n]=0;
CM[n]=0;
//initialisation de c  adica c=1 la intrare pina la mom T
if  (t[n]<T)
{for ( j=0; j<=ny; j++){
 c[j]=1;
 cim1[j]=1;}  ;}
else{ for ( j=0; j<=ny; j++){
 c[j]=0;
cim1[j]=0;} ;}


for (i=1; i<=nx; i++){
coefvar();
remplir();
inv();
// enlever le sauver pour aller + vite?
//sauver();
// nouveau B(t+dt)
B[i]=(B[i]+c[0]*dt)/(1+(K+c[0])*dt);


//moyenne de B(t) sur le reacteur
if(i>i1 && i<i2) {
M[n]=M[n]+B[i]*dx0/(x2-x1) ;
CM[n]=CM[n]+c[0]*dx0/(x2-x1);

/*if(i>i1 && i<=i2) {
M[n]=M[n]+(B[i]+B[i-1])/2/(i2-i1) ;
CM[n]=CM[n]+(c[0]+cim1[0])/2/(i2-i1);      */
}
deltac[i]=0;
delta99[i]=0.;

/* Epaisseur integrale de c  et epaisseur 99% */
for ( j=0; j<=ny; j++)
{
if((c[j]-c[0])/(c[ny]-c[0])<0.99){delta99[i]=y[j];}
deltac[i]=deltac[i]+(1-c[j])/(1-c[0])*dy0;
cim1[j]=c[j];}

}
printf(" t = %7f BM = %7f CM = %7f \r",t[n],M[n],CM[n]);

 f2 = fopen("BM1.OUT", "a");
 fprintf(f2,"%7f %7f %7f \n",t[n], M[n],CM[n]);
   fclose(f2);             
/*
if((n-10*(n/10))==1){
printf("%d \n",n);
 f3   = fopen("CFw.OUT", "a");
for(i=1; i<=nx; i++){ 
 fprintf(f3," %7f  %7f  %7f  %7f %7f %7f %7f\n",
    t[n],x[i],cw0[i],fl[i],B[i],deltac[i],delta99[i]);}
fclose(f3);
 
//sauver();
//getchar();
 } */
  
//getchar();
}
printf("\n");
 
return (0);}

/* PYL  22 05 2001 */


